import {CUpdateForm, CUsersList, SearchUserInput, CUpdateAdminForm} from "./index";
import {gql, urlUpload, actionPromise, actionGoodCard, getGoods,
    actionUserFindOne, updateImgAction, actionAuthLogin, actionAuthLogout,
    actionUserUpdate} from "../reducers";
import {createStore, combineReducers, applyMiddleware, bindActionCreators} from 'redux';
import { connect } from "react-redux";
import { useEffect, useState, useRef } from "react";

import {BrowserRouter as Router, Route, Link, Switch, Redirect, useHistory} from 'react-router-dom';


const YourProfile = ({state, isImg, token, onLogin, onLogout, updateImg, 
                        updateUser, isUserAdmin, status, data = {}, getData, 
                        match:{params:{_id}}, isAdmin = [], isOwner}) => {

    const history = useHistory();

    const formRef = useRef(null);
    const [nick, changeNick] = useState(null);
    const [newLogin, changeLogin] = useState(null);
    const [password, changePassword] = useState(null);
    const [password2, changePassword2] = useState(null);
    const [isUpdateImg, changeImg] = useState(false);
    const [isUpdatePage, changePage] = useState(false);
    const [newImage, getImage] = useState({});

     useEffect(() =>  history.location.pathname.includes(`/profile/`) ? getData(`${isOwner.id}`) : getData(`${_id}`),[history.location.pathname])
     
     const date = new Date(data ? +data.createdAt : 0);
     const [showUpdate, onShow] = useState(false);
     const [showAdminUpdate, onAdmin] = useState(false);
     const [searchInput, changeValue] = useState("Пошук");

     console.log(status);
     console.log(data);
     if(status == "RESOLVED"){
        // history.location.pathname.includes(`/profile/`) ? getData(`${isOwner.id}`) : getData(`${_id}`)
        return (
            <>
            <div className = "userSearch">
                <input type = "text" placeholder = "Пошук юзера" onChange = {e => changeValue(e.target.value)} onKeyDown = {(e) => e.keyCode == 13 && history.push(`/searchUser/${searchInput}`)}/>
                <Link to = {"/searchUser/" + searchInput}>
                    <button>Пошук</button>
                </Link>
            </div>

                <div className = "profilePage">
                    
                    {(isUserAdmin )&& 
                    <div className = "adminSmile">
                    <svg  xmlns="http://www.w3.org/2000/svg" width="30" height="30" fill="currentColor" class="bi bi-emoji-sunglasses-fill" viewBox="0 0 16 16">
                    <path d="M8 16A8 8 0 1 0 8 0a8 8 0 0 0 0 16zM2.31 5.243A1 1 0 0 1 3.28 4H6a1 1 0 0 1 1 1v.116A4.22 4.22 0 0 1 8 5c.35 0 .69.04 1 .116V5a1 1 0 0 1 1-1h2.72a1 1 0 0 1 .97 1.243l-.311 1.242A2 2 0 0 1 11.439 8H11a2 2 0 0 1-1.994-1.839A2.99 2.99 0 0 0 8 6c-.393 0-.74.064-1.006.161A2 2 0 0 1 5 8h-.438a2 2 0 0 1-1.94-1.515L2.31 5.243zM4.969 9.75A3.498 3.498 0 0 0 8 11.5a3.498 3.498 0 0 0 3.032-1.75.5.5 0 1 1 .866.5A4.498 4.498 0 0 1 8 12.5a4.498 4.498 0 0 1-3.898-2.25.5.5 0 0 1 .866-.5z"/>
                    </svg>
                    <span>admin</span>
                    </div>
                    }
                    
                    { isOwner ? <h2>Привіт, {data.nick || "людино"}!</h2> : <h2>{data.nick}</h2>}

                    <img src={data.avatar ? `${urlUpload}/${data.avatar.url}`: 'https://pngicon.ru/file/uploads/picca-1.png'} />
                    <span>
                        Сторінку створено {`${date.getDate()}. ${date.getMonth() + 1}. ${date.getFullYear()} о ${date.getHours()}: ${date.getMinutes()}: ${date.getSeconds()}  `}
                    </span>
                    {(( isOwner) || isAdmin)  &&
                    <span>
                        <button  onClick = {() => onShow(!showUpdate)}>Редагувати</button>
{/* 
                        Пс.. не подобається аватар, логін чи нікнейм? То зміни їх
                        <div>
                            <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-arrow-right" viewBox="0 0 16 16">
                            <path fill-rule="evenodd" d="M1 8a.5.5 0 0 1 .5-.5h11.793l-3.147-3.146a.5.5 0 0 1 .708-.708l4 4a.5.5 0 0 1 0 .708l-4 4a.5.5 0 0 1-.708-.708L13.293 8.5H1.5A.5.5 0 0 1 1 8z"/>
                            </svg>
                            <span className = "click" onClick = {() => onShow(!showUpdate)}>ТИЦ</span>
                        </div> */}
                    </span>
                    }
                    {showUpdate && 
                    <div className = "updateWrapper">
                    <h4>Редагування</h4>
                    <input onChange = {(e) => changeNick(e.target.value)} placeholder = "Новий нікнейм"/>
                    <input onChange = {(e) => changeLogin(e.target.value)} placeholder = "Новий логін"/>
                    <input onChange = {(e) => changePassword(e.target.value)} placeholder = "Новий пароль"/>
                    <input onChange = {(e) => changePassword2(e.target.value)} placeholder = "Повторіть пароль"/>
                    <input type="file"  name="photo" id='photo' 
                      onChange={(ev) => {
                        updateImg(ev.target.files[0])
              
                        changeImg(true);
                      }
                        }/>
                    <button onClick = {() => {
              
                      let newUser = {}
                      newUser._id = data._id;
                      if(nick){
                        newUser.nick = nick;
                      }
                      if (newLogin){
                        newUser.login = newLogin ;
                        }



                      if (password && password == password2) {
                        newUser.password = password;
                      } else if (password !== password2) {
                        history.push("/loginError");
                        return
                      }
                      if(isUpdateImg) {

                        newUser.avatar = {};
                        newUser.avatar._id = isImg._id;
                        newUser.avatar.url = isImg._url;
                      }
                      updateUser(newUser);
                      

                      !isAdmin ? onLogout() : window.location.reload();

                       
                       
                    }}>Зберегти</button>
                    {isAdmin && <button className = "redAlert">Видалити юзера</button>}
                  </div>

                        
                    // <CUpdateForm id = {data._id}/>
                    }
                    

                    
                </div>
            </>
    )
    } 
    else {
        //history.location.pathname.includes(`/profile/`) ? getData(`${isOwner.id}`) : getData(`${_id}`)
        
        // history.push("/login")
        return(
            <>
            </>
        )
    }
}

const mapStateToProps = state => ({
     state: state,

     status: state.promiseRed && state.promiseRed.user &&
     state.promiseRed.user.payload && state.promiseRed.user &&
     state.promiseRed.user.status,

     data: state.promiseRed && state.promiseRed.user &&
     state.promiseRed.user.payload && state.promiseRed.user.payload.data &&
     state.promiseRed.user.payload.data.UserFindOne,
     
     token: state.auth && state.auth.token,

     isUserAdmin: state.promiseRed && state.promiseRed.user &&
     state.promiseRed.user.payload && state.promiseRed.user.payload.data &&
     state.promiseRed.user.payload.data.UserFindOne && 
     state.promiseRed.user.payload.data.UserFindOne.acl &&
     state.promiseRed.user.payload.data.UserFindOne.acl.indexOf("admin") > -1,

     isOwner: state.auth && state.auth.payload && state.auth.payload.sub &&
     state.auth.payload.sub,

     isImg: state.promiseRed && state.promiseRed.photo &&
     state.promiseRed.photo.payload && state.promiseRed.photo.payload,

     isAdmin: state.auth && state.auth.payload && state.auth.payload.sub &&
     state.auth.payload.sub.acl && state.auth.payload.sub.acl.indexOf("admin") > -1
  });


  
  const mapDispatchToProps = dispatch => bindActionCreators({
    getData: actionUserFindOne,
    updateImg: updateImgAction,
    updateUser: actionUserUpdate,
    onLogout: actionAuthLogout,
    onLogin: actionAuthLogin
  }, dispatch);

const CYourProfile = connect(mapStateToProps, mapDispatchToProps)
(YourProfile)
export default CYourProfile;


  {/* <div class="spinner-border text-secondary" role="status">
  <span class="sr-only"></span>
</div> */}